//+------------------------------------------------------------------+
//|                                                  Racing-v2.mq4   |
//|                      Copyright  2006 Sunwest3d                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "EA Sample by Sunwest3D Copyright  2006"

extern int SMAfast = 12;
extern int SMAslow = 65;
extern double TakeProfit = 40;
extern double ProfitModifySL=15;
extern double StopLoss= 60;

extern double TrailingStop=0;
extern double Slippage = 3;
extern double Lots=0.1;

extern color clOpenBuy = Blue;
extern color clOpenSell = Red;
extern color clCloseBuy = Aqua;
extern color clCloseSell = Violet;
extern color clModiBuy = Blue;
extern color clModiSell = Red;


int Position=0;
int    Magic;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   TrailingStop= ProfitModifySL+10;
   Position=0;
   Magic = Period()+777;
   return(0);
  }
  
  
//+------------------------------------------------------------------+
//|     Start of the EA Sample                                       |
//+------------------------------------------------------------------+
int start()
  {
   double SMAf,SMAsh,SMAsl;
   
    SMAsh=iMA(Symbol(),0,SMAslow,0,MODE_SMA,PRICE_HIGH,1);
    SMAsl=iMA(Symbol(),0,SMAslow,0,MODE_SMA,PRICE_LOW,1);
    SMAsh=SMAsh+(SMAsh-SMAsl);
    SMAsl=SMAsl-(SMAsh-SMAsl);


    
   if (Volume[0]==1 && OrdersTotal()==0)
   {
      if (Open[0]>SMAsh)   {fBuy();Position=1;}
      if (Open[0]<SMAsl)   {fSell();Position=2;}   
   } 
   else
   {                 
      if(ProfitModifySL>0) fModifySLWhenInProfit();
      if (TrailingStop>0)  fTrailStop();
      
      if (Open[0]<SMAsl && Position==1)   {fCloseOpenOrders();Position=0;}
      if (Open[0]>SMAsh && Position==2)   {fCloseOpenOrders();Position=0;}
      
   }

   return(0);
  }
// ***** End of Main Loop ******



//+------------------------------------------------------------------+
//| Buy                                                              |
//+------------------------------------------------------------------+
void fBuy()
{
   int ticket =OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,NULL,Magic,0,clOpenBuy); 
   if(ticket>0)
   {
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
   }
   else Print("Error opening BUY order : ",GetLastError());
   
}
//+------------------------------------------------------------------+
//| Sell                                                             |
//+------------------------------------------------------------------+
void fSell()
{
   int ticket =OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,Bid-TakeProfit*Point,NULL,Magic,0,clOpenSell); 
   if(ticket>0)
   {
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
   }
   else Print("Error opening SELL order : ",GetLastError());
}

//+------------------------------------------------------------------+
//| Scan through Order and if in profit by PrmSL Modify SL           |
//+------------------------------------------------------------------+
void fModifySLWhenInProfit()
{
   for (int i=0; i<OrdersTotal(); i++) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
         {
            if (OrderType()==OP_BUY && Bid-OrderOpenPrice()>=ProfitModifySL*Point)
               if (OrderStopLoss()<OrderOpenPrice())  fModifyStopLoss(OrderOpenPrice());
               
            if (OrderType()==OP_SELL && OrderOpenPrice()-Ask>=ProfitModifySL*Point) 
               if (OrderStopLoss()>OrderOpenPrice())  fModifyStopLoss(OrderOpenPrice());
         } 
      } 
    }
}


//+------------------------------------------------------------------+
//| Modify Stop Loss                                                 |
//+------------------------------------------------------------------+
void fModifyStopLoss(double tStopLoss) 
{ 
   bool result = OrderModify(OrderTicket(),OrderOpenPrice(),tStopLoss,OrderTakeProfit(),0,NULL); 
   
   if (result) Print("StopLoss Modified for ticket ",OrderTicket()," to ",tStopLoss);
   else Print("Could not modify Stop Loss for ticket ",OrderTicket()," to ",tStopLoss);
   
}


//+------------------------------------------------------------------+
//| Trailling Stop Loss                                              |
//+------------------------------------------------------------------+
void fTrailStop()
{
   for (int i=0; i<OrdersTotal(); i++) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
         {
            if (OrderType()==OP_BUY) 
            { 
               if (Bid-OrderOpenPrice()>TrailingStop*Point) 
               { 
                  if (OrderStopLoss()<Bid-TrailingStop*Point) 
                     fModifyStopLoss(Bid-TrailingStop*Point); 
               }
            }
            if (OrderType()==OP_SELL)
            {
               if (OrderOpenPrice()-Ask>TrailingStop*Point) 
               {
                  if (OrderStopLoss()>Ask+TrailingStop*Point || OrderStopLoss()==0)  
                     fModifyStopLoss(Ask+TrailingStop*Point); 
               }
                   
            } 
         } 
      } 
    } 
}

//+------------------------------------------------------------------+
//| Close all running order                                          |
//+------------------------------------------------------------------+
void fCloseOpenOrders()
{
   bool tClosing;
   
   for (int i=0; i<OrdersTotal(); i++) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
         {
            if (OrderType()==OP_BUY)  tClosing = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), Slippage, clCloseBuy );
            if (OrderType()==OP_SELL) tClosing = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), Slippage, clCloseSell );
         } 
      } 
    }
    //return;
}

